@echo off

rem RandomSoundBoard.bat
rem 2008-10-22
rem Chieh Cheng
rem http://www.CynosureX.com/

rem GNU General Public License (GPL), Version 2, June 1991

  setlocal

  set scriptPath=%~d0%~p0
  set path=%scriptPath%;%path%

  call SetNumberOfArguments.bat %*

  if not %NumberOfArguments% equ 3 goto :help

  set directory=%~1
  set min=%2
  set max=%3
  set executable="%SystemDrive%\Program Files\Windows Media Player\wmplayer.exe"

  if exist %executable% goto :next
  echo Windows Media Player does not exist on this computer.
  echo Please install it and try again.
  goto :end

:next
  if exist "%directory%" goto :continue
  echo "%directory%" does not exist. Please specify a directory that exists.
  goto :end

:continue
  call :createPlayList
  if "%numberOfLines%" == "0" (
    echo There are no sound files to play in "%directory%".
    goto :end
  )

:loop
  call SetVariableToOutput.bat Random.bat 1 %numberOfLines%
  set soundNum=%OutputVariable%

  call SetVariableToOutput.bat GetTempPathName.bat %~n0
  set tempFile=%OutputVariable%

  type "%playListFile%" | find "[%soundNum%]" > "%tempFile%"
  call SetVariableToOutput.bat type "%tempFile%"
  set line=%OutputVariable%
  del "%tempFile%"

  call SetVariableToOutput.bat Token.bat "%line%" "]" 2
  set sound=%OutputVariable%
  start %executable% "%directory%\%sound%"

  call SetVariableToOutput.bat Random.bat %min% %max%
  set wait=%OutputVariable%
  echo Sleeping for %wait% seconds
  call Sleep.bat %wait%
  goto :loop

  goto :end

:createPlayList
  set playListFile=%temp%\PlayList.txt
  if exist "%playListFile%" del "%playListFile%"

  call SetVariableToOutput.bat GetTempPathName.bat %~n0
  set tempFile=%OutputVariable%
  dir /B "%directory%"\*.mp3 >> "%tempFile%" 2> NUL
  dir /B "%directory%"\*.wav >> "%tempFile%" 2> NUL
  dir /B "%directory%"\*.wma >> "%tempFile%" 2> NUL
  call AddLineNumbers.bat "%tempFile%" > "%playListFile%"
  del %tempFile%

  call SetVariableToOutput.bat NumberOfLines.bat "%playListFile%"
  set numberOfLines=%OutputVariable%
  goto :eof
  
:help
  echo   Usage: %~n0%~x0 "directory" min max
  echo.
  echo          min The minimum number of seconds to wait.
  echo          max The maximum number of seconds to wait.
  echo.
  echo          If you want a consistent period between playing
  echo          sounds, just set min and max to the same number.
  echo.

:end
